#!/usr/bin/env python
#coding=utf-8
import pygtk
pygtk.require('2.0')
import gtk.glade
import pango
import gobject
import pymplayer
from system import *
from commondialog import *
gtk.glade.bindtextdomain(APP_NAME, local_path)
from classfmt import *
from formatlist import *

ICON=gtk.gdk.pixbuf_new_from_file(ui_path+"pyvideoconv.png")
import os
import sys
import subprocess,time
import string
import thread
import re
import threading
fmt_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
customfmtiter=fmt_store.append([_("CustomFormat"),"CustomFormat"])
for key in formatlist.list:
    fmt_store.append([_(key),key])


class MainWin:
    def __init__ (self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"MainWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('MainWin')
        self.win.set_icon(ICON)
        CR=self.CR=gtk.CellRendererText()
        self.cfmt= xml.get_widget('CFmt')
        self.cfmt.set_model(fmt_store)
        self.cfmt.pack_start(self.CR,False)
        self.cfmt.add_attribute(self.CR, "text",0)
        self.tcommand= xml.get_widget('TCommand')
        self.cvideochangesize= xml.get_widget('CVideoChangeSize')
        self.svideowidth= xml.get_widget("SVideoWidth")
        self.svideoheight= xml.get_widget("SVideoHeight")
        self.lwidth= xml.get_widget("LWidth")
        self.lheight= xml.get_widget("LHeight")
        self.tvfiles= xml.get_widget("TVFiles")
        self.tvfiles.connect('drag_data_received', self.ondrag)
        self.tvfiles.drag_dest_set( gtk.DEST_DEFAULT_MOTION |gtk.DEST_DEFAULT_HIGHLIGHT | gtk.DEST_DEFAULT_DROP,[ ( 'text/uri-list', 0, 80 ) ], gtk.gdk.ACTION_COPY)
        self.eoutfile= xml.get_widget("EOutFile")
        self.foutpath= xml.get_widget("FOutPath")
        if os.path.exists(preferences["general"]["lastoutputpath"].strip()):
            self.foutpath.set_filename(preferences["general"]["lastoutputpath"].strip().decode(sys.getfilesystemencoding()))
        self.medit= xml.get_widget("MEdit")
        self.mdel= xml.get_widget("MDel")
        self.menu= xml.get_widget("Menu")
        self.hchangesize= xml.get_widget("HChangeSize")
        self.cdsize= xml.get_widget("CDSize")
        self.cstarttime= xml.get_widget('CStartTime')
        self.cendtime= xml.get_widget('CEndTime')
        self.estarttime= xml.get_widget('EStartTime')
        self.eendtime= xml.get_widget('EEndTime')
        self.csetasample= xml.get_widget('CSetASample')
        self.esrate= xml.get_widget('ESRate')
        self.files=FILES(self.tvfiles)
    def filesettings(self,*args):
        selected=self.tvfiles.get_selection().get_selected()
        iter= selected[1]
        if iter!=None:
            filesettingwin.go(self.files.model.get_value(iter,1))
    def delfile(self,*args):
        selected=self.tvfiles.get_selection().get_selected()
        iter= selected[1]
        if iter!=None:
            self.files.remove(iter)
    def encode(self,a=None,b=None,c=None):
        if len(self.files.settings)==0:
            msgbox("ERROR:","ERROR:","No inputfile choosen.")
        else:
            preferences["general"]["lastoutputpath"]=filecode(self.foutpath.get_filename())
            saveconfig(preferences)
            outputwin.run(self.files.settings,self.foutpath.get_filename())
    def ondrag(self,widget, context, x, y, selection, target_type, timestamp):
        uri = selection.data.strip()
        if uri=="" or uri==None:
            return
        uri_splitted = uri.split()
        for uri in uri_splitted:
            uri=uri.replace("|",":")
            self.files.add((uritofilename(uri)))
        context.finish(True,False) 
        return True
    def setmenu(self,*args):
        if self.tvfiles.get_selection().get_selected()[1]!=None:
            self.medit.show()
            self.mdel.show()
        else:
            self.medit.hide()
            self.mdel.hide()
    def keypress(self,widget,event,*args):
        if gtk.gdk.keyval_name(event.keyval) == "Delete":
            self.delfile()
    def popupmenu(self,widget,event,*args):
        if event.button is 3:
            self.setmenu()
            self.menu.popup(None,None,None,event.button,event.time,None)
    def preferences(self,*args):
        preferenceswin.go()
    def close(self,*args):
        gtk.main_quit()
    def about(self,*args):
        aboutwin.win.run()
        aboutwin.win.hide()
    def on_CFmt_changed(self,*args):
        if self.cfmt.get_active_iter()==None:
            return
        if fmt_store.get_value(self.cfmt.get_active_iter(),1)=="CustomFormat":
            setwin.show()
        else:
            fmtinfo.data=dict(formatlist.list[fmt_store.get_value(self.cfmt.get_active_iter(),1)])
            self.refresh()
    def on_menuitem3_activate(self,*args):
        setwin.show()
    def refresh(self):
        self.tcommand.get_buffer().set_text("mencoder "+fmtinfo.getcmd())
        self.cvideochangesize.set_active(fmtinfo.data["changesize"])
        if fmtinfo.data["changesize"]:
            self.hchangesize.show()
        else:
            self.hchangesize.hide()
        self.cstarttime.set_active(fmtinfo.data["starttime"]["enable"])
        self.estarttime.set_text(fmtinfo.data["starttime"]["value"])
        if fmtinfo.data["starttime"]["enable"]:
            self.estarttime.show()
        else:
            self.estarttime.hide()
        self.cendtime.set_active(fmtinfo.data["endtime"]["enable"])
        self.eendtime.set_text(fmtinfo.data["endtime"]["value"])
        if fmtinfo.data["endtime"]["enable"]:
            self.eendtime.show()
        else:
            self.eendtime.hide()
        self.csetasample.set_active(fmtinfo.data["resample"])
        self.esrate.set_text(fmtinfo.data["srate"])
        if fmtinfo.data["resample"]:
            self.esrate.show()
        else:
            self.esrate.hide()
        self.cdsize.set_active(fmtinfo.data["dsize"])
        self.svideowidth.set_text(fmtinfo.data["width"])
        self.svideoheight.set_text(fmtinfo.data["height"])
    def sizechange(self,a="",b="",c=""):
        fmtinfo.data["changesize"]=self.cvideochangesize.get_active()
        self.refresh()
    def widthchange(self,a="",b="",c=""):
        fmtinfo.data["width"]=str(int(self.svideowidth.get_value()))
        self.refresh()
    def heightchange(self,a="",b="",c=""):
        fmtinfo.data["height"]=str(int(self.svideoheight.get_value()))
        self.refresh()
    def on_BBrowseInFile_clicked(self,a="",b="",c=""):
        files=open_file_dialog()
        if files:
            for file in files:
                self.files.add(file)
    def cleanfiles(self,*args):
        self.files.clear()
    def on_CDSize_toggled(self,a=None,b=None,c=None):
        fmtinfo.data["dsize"]=self.cdsize.get_active()
        self.refresh()
    def on_EStartTime_changed(self,a=None,b=None,c=None):
        fmtinfo.data["starttime"]["value"]=self.estarttime.get_text()
        self.refresh()
    def on_EEndTime_changed(self,a=None,b=None,c=None):
        fmtinfo.data["endtime"]["value"]=self.eendtime.get_text()
        self.refresh()
    def on_CStartTime_toggled(self,a=None,b=None,c=None):
        fmtinfo.data["starttime"]["enable"]=self.cstarttime.get_active()
        self.refresh()
    def on_CEndTime_toggled(self,a=None,b=None,c=None):
        fmtinfo.data["endtime"]["enable"]=self.cendtime.get_active()
        self.refresh()
    def setasample(self,a=None,b=None,c=None):
        fmtinfo.data["resample"]=self.csetasample.get_active()
        self.refresh()
    def srate(self,a=None,b=None,c=None):
        fmtinfo.data["srate"]=self.esrate.get_text()
        self.refresh()

class FILES():
    def __init__(self,TreeView):
        self.tv=TreeView
        self.model=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
        self.tfilename=gtk.TreeViewColumn(_("Filename"))
        self.tv.insert_column(self.tfilename,-1)
        self.tpath=gtk.TreeViewColumn(_("Path"))
        self.tv.insert_column(self.tpath,-1)        
        self.CR=gtk.CellRendererText()
        self.tfilename.pack_start(self.CR,False) 
        self.tpath.pack_start(self.CR,False)
        self.tfilename.add_attribute(self.CR, "text",0)
        self.tpath.add_attribute(self.CR, "text",1)
        self.tv.set_model(self.model)
        self.settings={}
    def add(self,filename):
        if len(filename)>7:
            if filename[:7]=="file://":
                filename=filename[7:]
        if not self.settings.has_key(filename):
            __fileinfo=pymplayer.videofileinfo(mencoder_path+preferences["mencoder"]["mplayercmd"])
            __fileinfo.getfileinfo(filename)
            if  __fileinfo.width != 0:
                self.model.append([os.path.basename(filename),filename])
                self.settings[filename]=FILESETTING(filename)
    def clear(self):
        self.settings={}
        self.model.clear()
    def remove(self,iter):
        filename=self.model.get_value(iter,1)
        if self.settings.has_key(filename):
            del self.settings[filename]
            self.model.remove(iter)

#read formatlist
fmtset_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
confmt_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
audiocodec_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
videocodec_store=gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)
for key in ContainerList.data:
    ContainerList.data[key]["iter"]=confmt_store.append([ContainerList.data[key]["name"],key])
for key in VideoList.data:
    VideoList.data[key]["iter"]=videocodec_store.append([VideoList.data[key]["name"],key])
for key in AudioList.data:
    AudioList.data[key]["iter"]=audiocodec_store.append([AudioList.data[key]["name"],key])

class SetWin:
    def __init__ (self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"SetWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('SetWin')
        self.econcmd= xml.get_widget('EConCmd')
        self.evideocmd= xml.get_widget('EVideoCmd')
        self.eaudiocmd= xml.get_widget('EAudioCmd')
        self.efpscmd= xml.get_widget('EFpsCmd')
        self.efps= xml.get_widget('EFps')
        self.cfmtset= xml.get_widget('CFmtSet')
        self.ecfmtset= xml.get_widget('ECFmtSet')
        self.eothercmd= xml.get_widget('EOtherCmd')
        self.win.set_icon(ICON)
        #init combox
        self.cconfmt= xml.get_widget('CConFmt')
        self.cconfmt.set_model(confmt_store)
        self.caudiocodec= xml.get_widget('CAudioCodec')
        self.caudiocodec.set_model(audiocodec_store)
        self.cvideocodec= xml.get_widget('CVideoCodec')
        self.cvideocodec.set_model(videocodec_store)
        CR=self.CR=gtk.CellRendererText()
        self.cconfmt.pack_start(self.CR,False) 
        self.caudiocodec.pack_start(self.CR,False)
        self.cvideocodec.pack_start(self.CR,False)
        self.cconfmt.add_attribute(self.CR, "text",0)
        self.caudiocodec.add_attribute(self.CR, "text",0)
        self.cvideocodec.add_attribute(self.CR, "text",0)
        self.cfmtset.set_model(fmtset_store)
        self.cfmtset.clear_attributes
        self.cfmtset.pack_start(self.CR,False)
        self.cfmtset.add_attribute(self.CR, "text",0)
    def show(self):
        self.refresh()
        self.fmtset_refresh()
        self.win.show()
    def refresh(self):
        self.cconfmt.set_active_iter(ContainerList.data[fmtinfo.data["Container"]]["iter"])
        self.caudiocodec.set_active_iter(AudioList.data[fmtinfo.data["audiocodec"]]["iter"])
        self.cvideocodec.set_active_iter(VideoList.data[fmtinfo.data["videocodec"]]["iter"])
        self.efps.set_text(fmtinfo.data["fps"])
        self.efpscmd.set_text(fmtinfo.fps.getcmd())
        self.econcmd.set_text(fmtinfo.container.getcmd())
        self.eaudiocmd.set_text(fmtinfo.audio.getcmd())
        self.evideocmd.set_text(fmtinfo.video.getcmd())
        self.eothercmd.set_text(fmtinfo.data["other"])
    def fmtset_refresh(self,name=None):
        fmtset_store.clear()
        fmtsetdict={}
        for key in formatlist.list:
            fmtsetdict[key]=fmtset_store.append([_(key),key])
        if name!=None:
            if fmtsetdict.has_key(name):
                self.cfmtset.set_active_iter(fmtsetdict[name])
    def on_CConFmt_changed(self,a="",b="",c=""):
        fmtinfo.data["Container"]=confmt_store.get_value(self.cconfmt.get_active_iter(),1)
        self.econcmd.set_text(fmtinfo.container.getcmd())
    def on_CVideoCodec_changed(self,a="",b="",c=""):
        fmtinfo.data["videocodec"]=videocodec_store.get_value(self.cvideocodec.get_active_iter(),1)
        self.evideocmd.set_text(fmtinfo.video.getcmd())
    def on_EFps_changed(self,a="",b="",c=""):
        fmtinfo.data["fps"]=self.efps.get_text()
        self.efpscmd.set_text("-ofps "+fmtinfo.data["fps"])
    def on_CAudioCodec_changed(self,a="",b="",c=""):
        fmtinfo.data["audiocodec"]=audiocodec_store.get_value(self.caudiocodec.get_active_iter(),1)
        self.eaudiocmd.set_text(fmtinfo.audio.getcmd())
    def on_CFmtSet_changed(self,a="",b="",c=""):
        if self.cfmtset.get_active_iter()==None:
            return
        fmtinfo.data=formatlist.list[fmtset_store.get_value(self.cfmtset.get_active_iter(),1)]
        self.refresh()
    def on_EOtherCmd_changed(self,a=None,b=None,c=None):
        fmtinfo.data["other"]=self.eothercmd.get_text()
    def close(self,a="",b="",c=""):
        self.win.hide()
        mainwin.refresh()
        fmt_store.clear()
        customfmtiter=fmt_store.append([_("CustomFormat"),"CustomFormat"])
        for key in formatlist.list:
            fmt_store.append([key,key])
        return True
    def setao(self,a="",b="",c=""):
        if ao.has_key(AudioList.data[fmtinfo.data["audiocodec"]]["type"]):
            ao[AudioList.data[fmtinfo.data["audiocodec"]]["type"]].setup()
            self.eaudiocmd.set_text(fmtinfo.audio.getcmd())
    def setvo(self,a="",b="",c=""):
        if vo.has_key(VideoList.data[fmtinfo.data["videocodec"]]["type"]):
            vo[VideoList.data[fmtinfo.data["videocodec"]]["type"]].setup()
            self.evideocmd.set_text(fmtinfo.video.getcmd())

    def savefmt(self,a=None,b=None,c=None):
        _fmtiter=self.cfmtset.get_active_iter()
        if _fmtiter!=None:
            _fmtname=fmtset_store.get_value(self.cfmtset.get_active_iter(),1)
        else:
            _fmtname=""
        text=input_text_dialog(_("Save:"),_("Save:"),_("Enter Format Name:"),_fmtname)
        if text!=None:
            formatlist.save(text,fmtinfo.data)
            self.fmtset_refresh(text)
    def delfmt(self,a=None,b=None,c=None):
        formatlist.delete(fmtset_store.get_value(self.cfmtset.get_active_iter(),1))
        self.fmtset_refresh()


def convertfeedback(win,infiles,outpath):
    i=0
    filescount=len(infiles)
    win.toutput.get_buffer().set_text("")
    for infile in infiles:
        i+=1
        filesstr=str(i)+"/"+str(filescount)+" "
        infile=infile.strip()
        infilename=os.path.basename(infile)
        cmd,outfile=infiles[infile].getcmds(outpath)
        outfilename=os.path.basename(outfile)
        outfile=filecode(outfile)
        cmd+=["-msglevel","all=1:statusline=5"]+subtitlecmd(infile)+getfontcmd()
        print cmd
        if win.stop:
            break
        win.pipe=runcmd(cmd)
        win.ppercent.set_fraction(0)
        printfb(_("converting %U.....\n\n").replace("%U",infile))
        __start=win.starttime
        __end=win.endtime
        __endbyte=win.endbyte
        if infiles[infile].data["changestarttime"]:
            __start=infiles[infile].data["starttime"]
        if infiles[infile].data["changeendtime"]:
            __end=infiles[infile].data["endtime"]- __start
            __endbyte=0
        while win.pipe.poll()==None:
                feedback=win.pipe.stdout.readline()
                #win.pipe.stdout.flush()
                win.setpercent(feedback,filesstr,outfile,outfilename,__start,__end,__endbyte)
        win.ppercent.set_fraction(1)
        feedback=win.pipe.stderr.read()
        if feedback !="":
            printfb(_("Error code:\n")+feedback)
        if win.pipe.returncode:
            printfb(infile+_(" convert error."))
        else:
            printfb(infile+_(" convert finfish."))
    win.ppercent.set_text(_("Finished"))
def printfb(str):
    buffer=outputwin.toutput.get_buffer()
    buffer.set_text(buffer.get_text(buffer.get_start_iter(),buffer.get_end_iter())+"\n"+str)


outputre=re.compile(r"Pos:[\s]*([\d]+\.[\d])+s[\s]*[\d]+f[\s]*\([\s]*([\d]+)%\).*Trem:[\s]*([\d]+)[^\d]*([\d]+)")

class OutputWin:
    def __init__(self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"OutputWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('OutputWin')
        self.toutput= xml.get_widget('TOutput')
        self.ppercent= xml.get_widget('PPercent')
       
    def run(self,infile,outpath):
        self.win.show()
        self.stop=False
        self.starttime=0.0
        if fmtinfo.data["starttime"]["enable"]:
            _match=re.compile(r"(?:([\d]{1,2}):){0,1}?(?:([\d]{1,2}):)?([\d]+)(\.[\d]{1,2})?$").match(fmtinfo.data["starttime"]["value"])
            if _match != None:
                self.starttime=float(_match.group(3))
                if _match.group(1)!=None:
                    self.starttime+=float(_match.group(1))*3600
                if _match.group(2)!=None:
                    self.starttime+=float(_match.group(2))*60
                if _match.group(4)!=None:
                    self.starttime+=float(_match.group(4))
        self.endtime=0.0
        self.endbyte=0.0
        if fmtinfo.data["endtime"]["enable"]:
            _match=re.compile(r"(?:([\d]{1,2}):)??(?:([\d]{1,2}):)?([\d]+)(\.[\d]{1,2})?$").match(fmtinfo.data["endtime"]["value"])
            if _match != None:
                self.endtime=float(_match.group(3))
                if _match.group(1)!=None:
                    self.endtime+=float(_match.group(1))*3600
                if _match.group(2)!=None:
                    self.endtime+=float(_match.group(2))*60
                if _match.group(4)!=None:
                    self.endtime+=float(_match.group(4))
            else:
                _match=re.compile(r"([\d]+)(MB|KB|B)").match(fmtinfo.data["endtime"]["value"].upper())
                if _match !=None:
                    if _match.group(2)=="MB":
                        _bytes=1048576.0
                    else:
                        if _match.group(2)=="KB":
                            _bytes=1024.0
                        else:
                            _bytes=1.0
                self.endbyte=int(_match.group(1))*_bytes
        self.thread=thread.start_new_thread(convertfeedback,(self,infile,outpath))
    def setpercent(self,output,filestr,outfile,outfilebasename,starttime,endtime,endbyte):
        if output=="":
            return
        if output[:4]=="Pos:":
            _match=outputre.match(output)
            if _match !=None:
                if _match.group(2)=="0" and _match.group(3)=="0" and _match.group(4)=="0":
                    self.ppercent.set_text(filestr+_(" : Unkown"))
                    self.ppercent.set_fraction(0)
                    return
                _pos=float(_match.group(1))
                _precent=int(_match.group(2))
                if endtime != 0:
                    _precent=max(int(((_pos)/endtime)*100),_precent)
                else:
                    if endbyte !=0:
                        _precent=max(int((os.stat(outfile).st_size/endbyte)*100),_precent)
                _precent=min(99,_precent)
                self.ppercent.set_text(outfilebasename+"   "+filestr+" : "+str(_precent)+"%")
                self.ppercent.set_fraction(_precent/100.0)
            else:
                printfb(output)
    def close(self,a=None,b=None,c=None):
        self.stop=True
        if self.pipe.poll()==None:
            pkill(self.pipe)
        self.win.hide()
        return True

def subtitlecmd(infile):
    cmd=[]
    if preferences["subtitle"]["usesub"].upper() == "TRUE":
        for item in subtitlelist:
            if os.path.exists(os.path.splitext(infile)[0]+os.extsep+item):
                cmd=["-sub",filecode(os.path.splitext(infile)[0]+os.extsep+item)]
                cmd+=getfontcmd()
    return cmd
     

class PreferencesWin:
    def __init__ (self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"PreferencesWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win = xml.get_widget('PreferencesWin')
        self.cusesub = xml.get_widget('CUseSub')
        self.tsub = xml.get_widget('TSub')
        self.echarset = xml.get_widget('ECharset')
        self.cusefont = xml.get_widget('CUseFont')
        self.fbfont = xml.get_widget('FBFont')
        self.emencodercmd = xml.get_widget('EMencoderCmd')
        self.eparameters = xml.get_widget('EParameters')
        self.data={}
    def refresh(self):
        if  self.data["subtitle"]["usesub"].upper()=="TRUE":
            self.cusesub.set_active(True)
            self.tsub.show()
        else:
            self.cusesub.set_active(False)
            self.tsub.hide()
        if self.data["subtitle"]["usefont"].upper()=="TRUE":
            self.cusefont.set_active(True)
            self.fbfont.show()
        else:
            self.cusefont.set_active(False)
            self.fbfont.hide()
        self.echarset.set_text(self.data["subtitle"]["charset"])
        self.eparameters.set_text(self.data["mencoder"]["parameters"])
        self.emencodercmd.set_text(self.data["mencoder"]["mencodercmd"])
        self.fbfont.set_font_name(self.data["subtitle"]["font"])
    def go(self):
        self.data=dict(preferences)
        self.refresh()
        response=self.win.run()
        if response==gtk.RESPONSE_OK:
            if self.cusesub.get_active():
                preferences["subtitle"]["usesub"]="TRUE"
            else:
                preferences["subtitle"]["usesub"]="FALSE"
            preferences["subtitle"]["charset"]=self.echarset.get_text()
            preferences["subtitle"]["font"]=self.fbfont.get_font_name()[:self.fbfont.get_font_name().rfind(" ")+1]
            if self.cusefont.get_active():
                preferences["subtitle"]["usefont"]="TRUE"
            else:
                preferences["subtitle"]["usefont"]="FALSE"
            preferences["mencoder"]["mencodercmd"]=self.emencodercmd.get_text()
            preferences["mencoder"]["parameters"]=self.eparameters.get_text()
            saveconfig(preferences)
        self.win.hide()
    def close(self,b=None,c=None):
        self.win.response(gtk.RESPONSE_CANCEL)
        return True
    def ok(self,dialog):
        self.win.response(gtk.RESPONSE_OK)
    def toggleusefont(self,a=None,b=None,c=None):
        if self.cusefont.get_active():
            self.fbfont.show()
        else:
            self.fbfont.hide()
    def toggleusesub(self,a=None,b=None,c=None):
        if self.cusesub.get_active():
            self.tsub.show()
        else:
            self.tsub.hide()

class AboutWin:
    def __init__(self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"AboutWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win = xml.get_widget('AboutWin')
    def close(self,a="",b="",c=""):
        self.win.response(gtk.RESPONSE_CANCEL)
        return True

class FileSettingWin:
    def __init__ (self):
        xml = self.xml = gtk.glade.XML(ui_path+'ui.glade',"FileSettingWin","pyvideoconv")
        xml.signal_autoconnect(self)
        self.win=win = xml.get_widget('FileSettingWin')
        self.drawfix= xml.get_widget('DRAWFIX')
        self.drawbox= xml.get_widget('DrawBox')
        self.exvideo=xml.get_widget('EXVideo')
        self.exvideo.connect_after("notify::expanded",self.togglevideo)
        self.exvideo.set_expanded(True)
        self.fvmax= xml.get_widget('FVMAX')#the full video 
        self.vp= xml.get_widget('VP')# the visible video port
        self.progress= xml.get_widget('PROGRESS')
        self.status= xml.get_widget('Status')
        self.lpos= xml.get_widget('LPos')
        self.bplay= xml.get_widget('BPlay')
        self.tcrop= xml.get_widget('TCrop')
        self.sbtop= xml.get_widget('SBTop')
        self.cbrename=xml.get_widget('CBRename')
        self.ename=xml.get_widget('EName')
        self.cbstarttime= xml.get_widget('CBStarttime')
        self.cbendtime= xml.get_widget('CBEndtime')
        self.sbstarttime= xml.get_widget('SBStarttime')
        self.sbendtime= xml.get_widget('SBEndtime')
        self.bpickstart= xml.get_widget('BPickStart')
        self.bpickend= xml.get_widget('BPickEnd')
        
        self.sbtop.tag="top"
        self.sbbuttom= xml.get_widget('SBButtom')
        self.sbbuttom.tag="buttom"        
        self.sbleft= xml.get_widget('SBLeft')
        self.sbleft.tag="left"
        self.sbright= xml.get_widget('SBRight')
        self.sbright.tag="right"
        self.bcropfull= xml.get_widget('BCropFull')
        self.bcrophelp= xml.get_widget('BCropHelp')
        self.tbs={}
        self.tbs["left"]=xml.get_widget('TBLeft')
        self.tbs["right"]=xml.get_widget('TBRight')
        self.tbs["top"]=xml.get_widget('TBTop')
        self.tbs["buttom"]=xml.get_widget('TBButtom')
        self.cropwidgets=[self.tcrop,self.sbtop,self.sbbuttom,self.sbleft,self.sbright,self.bcropfull,self.bcrophelp,self.tbs["top"],self.tbs["buttom"],self.tbs["left"],self.tbs["right"]]
        self.cbcrop= xml.get_widget('CBCrop')
        for item in self.tbs:
            self.tbs[item].connect("clicked",self.tbclick,item)
        self.tbsclicked="none"
        
        self.win.set_icon(ICON)
        self.mplayer=pymplayer.MPlayer()
        self.mplayer.handle_data=self.handle_data
        self.mplayer.handle_pos=self.handle_pos
        self.mplayer.args=["-noautosub","-vo",preferences["mencoder"]["vo"]]
        self.draw=None
        self.data={}
    def go(self,filename):
        self.filename=filename
        if self.draw != None:
            self.draw.destroy()
        self.draw= gtk.DrawingArea()
        self.draw.connect("button_press_event",self.drawclick)
        self.draw.connect("scroll_event",self.scroll)
        self.draw.set_events(gtk.gdk.BUTTON_PRESS_MASK|gtk.gdk.SCROLL)
        self.drawfix.put(self.draw,0,0)
        self.draw.realize()
        self.draw.show()
        #self.draw.set_double_buffered(False)
        self.mplayer.wid=getwid(self.draw.window)
        self.progress.set_value(0.0)
        self.time_length=0.0
        self.mplayer.mplayercmd=mencoder_path+preferences["mencoder"]["mplayercmd"]
        self.mplayer.start(filecode(filename))
        self.pos=0.0
        self.lpos.set_text("0.0")
        self.pause()
        self.load()
        self.setcropwidget()
        self.setvideosize()
        self.togglevideo()
        self.win.show()
    def setnamewidget(self):
        self.cbrename.set_active(self.data["autoname"])
        self.ename.set_text(self.data["outfilename"])
        if self.data["autoname"]:
            self.ename.hide()
        else:
            self.ename.show()
    def load(self,*args):
        self.data=dict(mainwin.files.settings[self.filename].data)
        if self.draw!=None:
            self.setvp()
        if self.data["crop"]["right"] is -1:
            self.data["crop"]["right"]=self.mplayer.width
        if self.data["crop"]["buttom"] is -1:
            self.data["crop"]["buttom"]=self.mplayer.height
        self.settimevalue()
        self.setnamewidget()
        return True     
    def save(self,*args):
        mainwin.files.settings[self.filename].data=dict(self.data)
        return True
    def settimevalue(self):
        self.cbstarttime.set_active(self.data["changestarttime"])
        self.cbendtime.set_active(self.data["changeendtime"])
        self.starttime,self.endtime=self.settimes()
        self.sbstarttime.set_range(0.0,self.mplayer.length)
        self.sbstarttime.set_value(self.data["starttime"])
        self.sbendtime.set_range(0,self.mplayer.length)
        if self.data["endtime"]!=-1:
            self.sbendtime.set_value(self.data["endtime"])
        else:
            self.sbendtime.set_value(self.mplayer.length)
            self.data["endtime"]=self.mplayer.length
    def settimes(self):
        if self.data["changestarttime"]:
            self.sbstarttime.show()
            self.bpickstart.show()
        else:
            self.sbstarttime.hide()
            self.bpickstart.hide()
        if self.data["changeendtime"]:
            self.sbendtime.show()
            self.bpickend.show()
        else:
            self.sbendtime.hide()
            self.bpickend.hide()
        if not self.data["changestarttime"]:
            _start=0
        else:
            _start= self.data["starttime"]
        if self.data["endtime"]==-1 or self.data["changeendtime"]==False:
            _end=self.mplayer.length
        elif self.data["endtime"]>=_start:
            _end=self.data["endtime"]
        else:
            _end=_start
            self.sbendtime.set_value(_end)
        if self.progress.get_value()<_start:
            self.progress.set_value(_start)
            self.mplayer.setpos(_start)
            self.pos=_start
        if self.progress.get_value()>_end:
            self.pause()
            self.mplayer.setpos(_end)
            self.progress.set_value(_end)
            self.pos=_end
        self.progress.set_range(_start,_end)
        return _start,_end
    def timeset(self,*args):
        self.data["changestarttime"]=self.cbstarttime.get_active()
        self.data["changeendtime"]=self.cbendtime.get_active()
        if self.data["changestarttime"]:
            self.data["starttime"]=self.sbstarttime.get_value()
        if self.data["changeendtime"]:
            self.data["endtime"]=self.sbendtime.get_value()
        self.start,self.end=self.settimes()
    def play(self,*args):
        if self.mplayer.paused and self.pos<self.end:
            self.mplayer.toggleplay()
            self.setstatus()
    def pause(self,*args):
        if not self.mplayer.paused:
            self.mplayer.toggleplay()
            self.setstatus()
    def setcropwidget(self):
        for item in self.cropwidgets:
            if self.data["crop"]["enable"]:
                item.show()
            else:
                item.hide()
        self.setvp()
    def close(self,*args):
        self.mplayer.stop()
        self.win.hide()
        return True
    def togglecrop(self,*args):
        self.data["crop"]["enable"]=self.cbcrop.get_active()
        self.setcropwidget()
        self.setstatus()
    def cropchange(self,sb,*args):
        self.data["crop"][sb.tag]=int(sb.get_value())
        self.showvp()
    def tbclick(self,tb,tbs,*args):
        if self.tbsclicked==tbs:
            self.tbsclicked="none"
            self.setstatus()
            return
        if tb.get_active():
            self.tbsclicked=tbs
            self.settbs()
    def settbs(self):
        for item in self.tbs:
            if item!=self.tbsclicked:
                if self.tbs[item].get_active()==True:
                    self.tbs[item].set_active(False)
        self.setstatus()
    def handle_pos(self,pos):
        self.progress.set_value(pos)
        self.pos=pos
        self.lpos.set_text(str(pos))
        if pos>self.end:
            self.pause()
    def handle_data(self,data):
        return True
    def setrename(self,*args):
        self.data["autoname"]=self.cbrename.get_active()
        if self.data["autoname"]:
            self.ename.hide()
        else:
            self.ename.show()
    def setname(self,*args):
        self.data["outfilename"]=self.ename.get_text()
    def setvideosize(self):
        self.draw.set_size_request(self.mplayer.width,self.mplayer.height)
        self.draw.queue_resize()
        self.fvmax.set_size_request(self.mplayer.width,self.mplayer.height)
        self.fvmax.queue_resize()
        self.setvp()
    def showvp(self):
        if self.data["crop"]["enable"]:
            vpright=self.data["crop"]["right"]
            vpbuttom=self.data["crop"]["buttom"]
            if vpright==-1:
                vpright=self.mplayer.width
            if vpbuttom==-1:
                vpbuttom=self.mplayer.height
            self.drawfix.move(self.draw,-self.data["crop"]["left"],-self.data["crop"]["top"])
            self.fvmax.move(self.vp,self.data["crop"]["left"],self.data["crop"]["top"])
            self.vp.set_size_request(vpright-self.data["crop"]["left"],vpbuttom-self.data["crop"]["top"])
            self.vp.queue_resize()
        else:
            self.fvmax.move(self.vp,0,0)
            self.drawfix.move(self.draw,0,0)
            self.vp.set_size_request(self.mplayer.width,self.mplayer.height)
    def togglevideo(self,*args):
        if self.exvideo.get_expanded():
            self.drawbox.show()
        else:
            self.drawbox.hide()
        self.win.resize_children()
        width,height=self.win.size_request()
        self.win.resize(width,height)
        return True
    def setvp(self):
        self.sbtop.set_value(self.data["crop"]["top"])
        self.sbbuttom.set_value(self.data["crop"]["buttom"])
        self.sbleft.set_value(self.data["crop"]["left"])
        self.sbright.set_value(self.data["crop"]["right"])
        self.showvp()
    def setpos(self,range, scroll, value,*args):
        if value < self.start:
            value=self.start
        elif value > self.end:
            value=self.end
        #self.pos=value
        #self.lpos.set_text(str(value))
        self.mplayer.setpos(value)
    def cropfull(self,*args):
        self.data["crop"]["top"]=0
        self.data["crop"]["buttom"]=self.mplayer.height
        self.data["crop"]["left"]=0
        self.data["crop"]["right"]=self.mplayer.width
        self.setvp()
    def scroll(self,draw,event):
        if self.data["crop"]["enable"] and self.tbsclicked!="none":
            if event.direction is gtk.gdk.SCROLL_UP or event.direction is gtk.gdk.SCROLL_LEFT:
                __step=-1
            else:
                __step=1
            if self.tbsclicked=="top":
                self.data["crop"]["top"]=max(0,min(self.data["crop"]["top"]+__step,self.data["crop"]["buttom"]))
            elif self.tbsclicked=="left":
                self.data["crop"]["left"]=max(0,min(self.data["crop"]["left"]+__step,self.data["crop"]["right"]))
            elif self.tbsclicked=="buttom":
                self.data["crop"]["buttom"]=max(self.data["crop"]["top"],min(self.data["crop"]["buttom"]+__step,self.mplayer.height))
            elif self.tbsclicked=="right":
                self.data["crop"]["right"]=max(self.data["crop"]["left"],min(self.data["crop"]["right"]+__step,self.mplayer.width))
            else:
                return
            self.setvp()
    def drawclick(self,draw,event):
        if self.data["crop"]["enable"]:
            if event.button==1:
                if self.tbsclicked!="none":
                    if self.tbsclicked=="top":
                        self.data["crop"]["top"]=int(event.y)
                    elif self.tbsclicked=="buttom":
                        self.data["crop"]["buttom"]=int(event.y)
                    elif self.tbsclicked=="left":
                        self.data["crop"]["left"]=int(event.x)
                    elif self.tbsclicked=="right":
                        self.data["crop"]["right"]=int(event.x)
                    self.setvp()
            elif event.button==3:
                if self.tbsclicked!="none":
                    if self.tbsclicked=="top":
                        self.data["crop"]["top"]=0
                    elif self.tbsclicked=="buttom":
                        self.data["crop"]["buttom"]=self.mplayer.height
                    elif self.tbsclicked=="left":
                        self.data["crop"]["left"]=0
                    elif self.tbsclicked=="right":
                        self.data["crop"]["right"]=self.mplayer.width
                    self.setvp()
        return True
    def getstart(self,*args):
        self.data["starttime"]=self.pos
        self.settimevalue()
    def getend(self,*args):
        self.data["endtime"]=self.pos
        self.sbendtime.set_value(self.pos)
        self.settimes()
    def backtostart(self,*args):
        self.setpos(None,None,self.start)
    def setstatus(self):
        status=""
        if self.mplayer.paused:
            status=_("[Paused]")+"   "
        else:
            status=_("[Playing]")+"    "
        if self.tbsclicked !="none" and self.data["crop"]["enable"]:
            status+=_("croping:")+_(self.tbsclicked+" side")
        self.status.push(0,status)
mainwin=MainWin()
setwin=SetWin()
outputwin=OutputWin()
preferenceswin=PreferencesWin()
aboutwin=AboutWin()        
filesettingwin=FileSettingWin()
    
